---
- hosts: all
  name: configuration play
  user: ubuntu
  become: true
  become_user: root

  gather_facts: false
  pre_tasks:
    - name: Install python for Ansible
      become: true
      raw: test -e /usr/bin/python || (apt -y update && apt install -y python-minimal)
      changed_when: false
    - setup: # aka gather_facts

  tasks:
  - name:    Install prerequisites
    apt:     name={{item}} update_cache=yes
    with_items:
      - apt-transport-https
      - ca-certificates
      - curl
      - software-properties-common
  #- setup: # aka gather_facts
# curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
  - name: Add Docker s official GPG key
    apt_key:
      url: https://download.docker.com/linux/ubuntu/gpg
      state: present


# sudo apt-key fingerprint 0EBFCD88
  - name: Verify that we have the key with the fingerprint
    apt_key:
      id: 0EBFCD88
      state: present


  # sudo add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu xenial stable"
  - name: Set up the stable repository
    apt_repository:
      repo: deb [arch=amd64] https://download.docker.com/linux/ubuntu bionic stable edge
      state: present
      update_cache: yes


  # sudo apt-get update
  - name: Update apt packages
    apt:
      update_cache: yes


  # sudo apt-get install docker-ce
  - name: Install docker
    apt:
      name: docker-ce
      state: present
      update_cache: yes

  - name: Start docker on boot
    systemd:
      name: docker
      state: started
      enabled: yes

  - name: Install docker-compose
    apt:
      name: docker-compose
      state: present
      update_cache: yes

  - name: Install python-pip
    apt:
      name: python-pip
      state: present
      update_cache: yes

  - name: Install python-jenkins
    pip:
      name: python-jenkins
      state: latest

  - name: Install lxml
    pip:
      name: lxml
      state: latest

  # sudo usermod -aG docker ubuntu
  - name: Add remote "ubuntu" user to "docker" group
    user:
      name: "ubuntu"
      group: "docker"
      append: yes

  - file:
      path: /opt/jenkins_home
      state: directory
      owner: ubuntu
      group: ubuntu
      mode: 0775

  - file:
      path: /home/ubuntu/docker_image
      state: directory
      owner: ubuntu
      group: ubuntu
      mode: 0775

  - copy:
      src: ~/Documents/GorillaLL/docker-jenkins/
      dest: /home/ubuntu/docker_image/
      owner: ubuntu
      group: ubuntu
      mode: 0664

  - docker_service:
      project_src: /home/ubuntu/docker_image
      state: absent

  - docker_service:
      project_name: Jenkins
      definition:
        version: '3.1'
        services:
          jenkins:
            build: /home/ubuntu/docker_image/Jenkins
            image: gl_jenkins:latest
            volumes:
              - /opt/jenkins_home:/var/jenkins_home
              - /var/run/docker.sock:/var/run/docker.sock
            ports:
              - 80:8080
              - 50000:50000
    register: output

  - name: "Pause till Jenkins its up"
    pause:
      seconds: 30

  - name: "create wordpress job in jenkins"
    jenkins_job:
      config: "{{ lookup('file', 'templates/wp-job.xml') }}"
      name: wordpress
      user: admin
      password: helloWorld
      url: "http://{{ jenkins_host }}"

  - name: "create wordpress automated job in jenkins"
    jenkins_job:
      config: "{{ lookup('file', 'templates/automated.xml') }}"
      name: wordpress-automated
      user: admin
      password: helloWorld
      url: "http://{{ jenkins_host }}"

  - debug:
      var: output

  - assert:
      that:
        - "jenkins.jenkins_jenkins_1.state.running"
